<?php
declare (strict_types = 1);

namespace app\admin\model;

use think\Model;use think\model\concern\SoftDelete;

/**
 * @mixin \think\Model
 */
class ConsultTemp extends Model
{
	use SoftDelete;
	protected $createTime="addtime";
	protected $updateTime="updatetime";
	protected $deleteTime = 'delete_time';
	
    public function CreateByZx($list,$merage){
        foreach ($list as $key=>&$item){
        	$item['id']=$item['id']?:null;
        	if(isset($item['spuCode'])==false){
        		$item['spuCode']= substr(makeNo("SPU"), 0, -2) . str_pad($key, 2, '0', STR_PAD_LEFT);
        	}
        	if(empty($item['specinfo'])==false){
        		foreach ($item['specinfo'] as &$v){
        			$v['spec_name'] = Specs::where("id",$v['spec_id'])->value("spec_name",'');
        			$v['spec_value_name'] = SpecValue::where("id",$v['spec_value_id'])->value("spec_value",'');
        		}
        	}
        	$item = array_merge($item,$merage);
        }
        $this->strict(false)->saveAll($list);
    }
    
   public function Brand(){
    	return $this->belongsTo(Brand::class,"brand_id")->bind(["brand_name"]);
   }
   
   public function Unit(){
    	return $this->belongsTo(Unit::class,'unit_id')->bind(['unit']);
   }
   
   public function Cat(){
    	return $this->belongsTo(Cat::class,'cat_id')->bind(["cat_name"=>'search']);
   }
   
    public function GetSpecinfoAttr($v){
    	return json_decode($v,true);
    }
    
    public function SetSpecinfoAttr($v){
        	return json_encode($v,JSON_UNESCAPED_UNICODE);
    }
    
    
    public function CreateGood($bidNo,$marage){
      $list =$this->where(["bidNo"=>$bidNo])->select();
      if($list->isEmpty()==false){
      	    $addGood=[];
      	    $combind =[];
            foreach ($list as $item){
                $addGood[]  = array_merge($item,$marage);
                $combind[]=[
                	"spuCode"=>$marage["paren_code"],
                	"good_name"=>$marage["paren_name"],
                	"childCode"=>$item["spuCode"],
                	"child_name"=>$item["good_name"],
                	"child_num"=>$item["good_num"],
                	];
            }
            if(empty($addGood)==false)$this->strict(false)->saveAll($addGood);
            if(empty($combind)==false)(new GoodCombind())->saveAll($combind);
      }
    }
}
